// tgl_triangle_flat.cpp

#include "tgl_triangle.h"

void ZB_fillTriangleFlat(ZBuffer *zb, ZBufferPoint *p0, ZBufferPoint *p1, ZBufferPoint *p2)
{
#if TGL_FEATURE_RENDER_BITS == 24
    unsigned char colorR, colorG, colorB;
#else
    int color;
#endif

#define INTERP_Z

#if TGL_FEATURE_RENDER_BITS == 24 

#define DRAW_INIT()				\
{						\
  colorR = p2->r>>8; \
  colorG = p2->g>>8; \
  colorB = p2->b>>8; \
}

#define PUT_PIXEL(_a)		\
{						\
    zz = z >> ZB_POINT_Z_FRAC_BITS;		\
    if ( ZCMP(zz,pz[_a]) ) \
	{				\
		  pp[3 * _a]     = colorR;\
		  pp[3 * _a + 1] = colorG;\
		  pp[3 * _a + 2] = colorB;\
		  pz[_a] = zz;				\
    }\
    z += dzdx;					\
}

#else

#define DRAW_INIT()				\
{						\
  color = RGB_TO_PIXEL(p2->r,p2->g,p2->b);	\
}
  
#define PUT_PIXEL(_a)				\
{						\
    zz = z >> ZB_POINT_Z_FRAC_BITS;		\
    if ( ZCMP(zz,pz[_a]) ) \
	{				\
      pp[_a] = color;				\
      pz[_a] = zz;				\
    }						\
    z += dzdx;					\
}
#endif /* TGL_FEATURE_RENDER_BITS == 24 */

#include "tgl_triangle_inc.h"
}
